import 'package:fis_lib_report/converts/pt_to_px_converter.dart';
import 'package:fis_lib_report/pages/helpler.dart';
import 'package:fis_lib_report/report/line.dart';
import 'package:fis_lib_report/report/rt_thickness.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class RLine extends StatefulWidget {
  final Line line;

  RLine(this.line);

  @override
  State<StatefulWidget> createState() {
    return _LineState(line);
  }
}

class _LineState extends State<RLine> {
  final Line line;
  _LineState(this.line);

  @override
  initState() {
    ///TODO(Loki):设置虚线or实线
    final borderStyle = line.borderStyle;

    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    final stroke = line.stroke!;
    final a = stroke.a!;
    final r = stroke.r!;
    final g = stroke.g!;
    final b = stroke.b!;
    final margin = line.margin ?? RTThickness.uniform(0);
    return Container(
      height: 10, //TODO(Loki):这里的Height在Json中没有
      alignment: Alignment.center,
      margin: EdgeInsets.only(
          top: margin.top!,
          bottom: margin.bottom!,
          right: margin.left!,
          left: margin.left!),
      width: PtToPxConverter.ptToPx(line.width),
      child: Divider(
        height: line.thickness,
        thickness: line.thickness,
        color: Color.fromARGB(a, r, g, b),
      ),
    );
  }
}
