import 'dart:typed_data';
import 'dart:convert' as convert;

import 'package:fis_lib_report/converts/alignment_convert.dart';
import 'package:fis_lib_report/converts/margin_convert.dart';
import 'package:fis_lib_report/converts/pt_to_px_converter.dart';
import 'package:fis_lib_report/pages/components/vid_image.dart';
import 'package:fis_lib_report/pages/helpler.dart';
import 'package:fis_lib_report/report/inputImage.dart';
import 'package:fis_lib_report/report/inputImageList.dart';
import 'package:fis_lib_report/report/static_image.dart';
import 'package:fis_lib_report/report_info/input_image_info.dart';
import 'package:fis_lib_report/report_info/input_image_list_info.dart';
import 'package:fis_lib_report/report_info/report_info.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class RStaticImage extends StatefulWidget {
  final StaticImage staticImage;

  RStaticImage(this.staticImage);
  @override
  State<StatefulWidget> createState() {
    return _RInputImageState();
  }
}

class _RInputImageState extends State<RStaticImage> {
  InputImageInfo? inputImageInfo;
  _RInputImageState();

  late Uint8List _bytes;

  @override
  initState() {
    _bytes = convert.base64Decode(widget.staticImage.source!);
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Row(
      mainAxisAlignment: AlignmentConvert.horizontalToMainConvert(
          widget.staticImage.horizontalAlignment),
      children: [
        Container(
          height: PtToPxConverter.ptToPx(widget.staticImage.imageHeight!),
          width: PtToPxConverter.ptToPx(widget.staticImage.imageWidth!),
          alignment: Alignment.center,
          margin: MarginConvert.marginConvert(widget.staticImage.margin),
          child: Image.memory(_bytes),
        ),
      ],
    );
  }
}
