import 'package:fis_lib_report/pages/helpler.dart';
import 'package:fis_lib_report/pages/paragraph_page.dart';
import 'package:fis_lib_report/report/element_type.dart';
import 'package:fis_lib_report/report/interfaces/block_element.dart';
import 'package:fis_lib_report/report/paragraph.dart';
import 'package:fis_lib_report/report/rt_Cell.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class RTCellPage extends StatefulWidget {
  const RTCellPage({required this.cell, Key? key}) : super(key: key);

  final RTCell cell;

  @override
  State<StatefulWidget> createState() {
    return _RTCellState();
  }
}

class _RTCellState extends State<RTCellPage> {
  List<IBlockElement>? _blocks = [];

  @override
  initState() {
    _blocks = widget.cell.blocks;
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return _blocks!.isEmpty
        ? Container(
            height: 30,
            decoration: TestBoxDecoration.buildDecoration(),
          )
        : Wrap(
            alignment: WrapAlignment.start,
            children: [
              ..._blocks!.map((e) {
                if (e.elementType!.name == ElementType.paragraph!.name) {
                  final paragraph = e as Paragraph;
                  return ParagraphPage(paragraph: paragraph);
                }
                return Container(
                    height: 30,
                    decoration: TestBoxDecoration.buildDecoration());
              }),
            ],
          );
  }
}
