import 'dart:convert';

import 'package:flutter/cupertino.dart';

enum ElementTagType {
  General,
  DiagnosticEntry,
}

class ElementTag {
  String? id;
  String? name;
  String? displayName;
  bool? isDefault;
  ElementTagType? elementTagType;

  ElementTag({
    required this.id,
    required this.name,
    required this.displayName,
    required this.elementTagType,
    required this.isDefault,
  });

  ElementTag.fromJson(Map<String, dynamic> json) {
    id = json['Id'];
    name = json['Name'];
    displayName = json['DisplayName'];
    isDefault = json['IsDefault'];
    elementTagType = ElementTagType.values
        .firstWhere((element) => element.name == json['ElementTagType']);
  }
}
