import 'package:fis_lib_report/report/interfaces/block_element.dart';
import 'package:fis_lib_report/report/interfaces/cell.dart';

class RTColumnDefinition {
  double? width;
  RTColumnDefinition(this.width);

  RTColumnDefinition.fromJson(Map<String, dynamic> json) {
    width = json["Width"];
  }
}

class RTRowDefinition {
  double? minHeight = 18;
  double? height;
  WidthTypeEnum? type;

  RTRowDefinition.fromJson(Map<String, dynamic> json) {
    minHeight = json['MinHeight'];
    height = json['Height'];
    type = WidthTypeEnum.values
        .firstWhere((element) => element.name == json['Type']);
  }
}

abstract class IGrid extends IBlockElement {
  List<RTColumnDefinition>? columnDefinitions;
  List<RTRowDefinition>? rowDefinitions;
}
