import 'package:fis_lib_report/report/borders.dart';
import 'package:fis_lib_report/report/element.dart';
import 'package:fis_lib_report/report/element_type.dart';
import 'package:fis_lib_report/report/interfaces/block_element.dart';
import 'package:fis_lib_report/report/interfaces/cell.dart';
import 'package:fis_lib_report/report/paragraph.dart';
import 'package:fis_lib_report/report/rt_color.dart';

class RTCell extends Element implements ICell {
  @override
  RTColor? background;

  @override
  List<IBlockElement>? blocks = [];

  @override
  WidthTypeEnum? heightType;

  @override
  WidthTypeEnum? widthType;

  Borders? borders;

  RTCell.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    final jsonBackground = json['Background'];
    background = RTColor.fromJson(jsonBackground);
    heightType = WidthTypeEnum.values
        .firstWhere((element) => element.name == json['HeightType']);
    widthType = WidthTypeEnum.values
        .firstWhere((element) => element.name == json['WidthType']);
    List<dynamic> jsonBlocks = json['Blocks'];
    jsonBlocks.forEach((map) {
      final jsonType = map['ElementType'];
      final type = ElementType.fromJson(jsonType);
      if (type.name == ElementType.paragraph!.name) {
        final block = Paragraph.fromJson(map);
        blocks!.add(block);
      }
    });
    final jsonBorders = json['Borders'];
    borders = Borders.fromJson(jsonBorders);
  }
}
