import 'package:fis_lib_report/report/interfaces/singleSelected.dart';
import 'package:fis_lib_report/report/text_element.dart';

class SingleSelected extends TextElement implements ISingleSelected {
  @override
  SelectorDisplayStyle? displayStyle;

  @override
  bool? isReadOnly;

  @override
  List<String>? items = [];

  SingleSelected.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    displayStyle = SelectorDisplayStyle.values
        .firstWhere((element) => element.name == json['DisplayStyle']);
    isReadOnly = json['IsReadOnly'];
    List<dynamic> jsonItems = json['Items'];
    if (jsonItems.isNotEmpty) {
      jsonItems.forEach((element) {
        items!.add(element);
      });
    }
  }
}
