import 'package:fis_lib_report/report/element_tag.dart';
import 'package:fis_lib_report/report/element_type.dart';
import 'package:fis_lib_report/report/interfaces/element.dart';
import 'package:fis_lib_report/report/interfaces/position_layout.dart';
import 'package:fis_lib_report/report/interfaces/report_element.dart';
import 'package:fis_lib_report/report/measure_tag.dart';
import 'package:fis_lib_report/report/rt_thickness.dart';
import 'package:uuid/uuid.dart';

abstract class ElementInfo {
  @override
  ElementType? elementType;

  @override
  int? index;

  @override
  MeasureTag? measureTag;

  @override
  IReportElement? parent;

  @override
  ElementTag? tag;

  @override
  String? id;

  ElementInfo.fromElement(IElement element) {
    elementType = element.elementType;
    index = element.index;
    measureTag = element.measureTag;
    parent = element.parent;
    tag = element.tag;
    id = element.id;
  }
}
