import 'package:fis_lib_report/converts/event_type.dart';
import 'package:fis_lib_report/report/element.dart';
import 'package:fis_lib_report/report/inputImage.dart';
import 'package:fis_lib_report/report/inputImageList.dart';
import 'package:fis_lib_report/report/interfaces/block_element.dart';
import 'package:fis_lib_report/report/interfaces/element.dart';
import 'package:fis_lib_report/report/interfaces/inputImageList.dart';
import 'package:fis_lib_report/report_info/block_element_info_interface.dart';
import 'package:fis_lib_report/report_info/element_info.dart';

class InputImageInfo extends ElementInfo implements IBlockElementInfo {
  int? column;

  bool? hasGap;

  bool? isReadOnly;

  bool? isSelected;

  FEventHandler<String>? onSelect = FEventHandler();

  InputImageInfo.fromElement(InputImage inputImage)
      : super.fromElement(inputImage) {
    column = inputImage.column;
    hasGap = inputImage.hasGap;
    isReadOnly = inputImage.isReadOnly;
  }

  @override
  List<ElementInfo>? elementInfos;

  void addImage(String imageUrl) {
    onSelect!.emit(this, imageUrl);
  }
}
